﻿using Android.App;
using Android.OS;
using Android.Support.V7.App;
using Android.Runtime;
using Android.Widget;
using Java.Lang;
using Com.Cloudpos.Printer;
using Com.Cloudpos;
using Android.Util;
using Com.Cloudpos.Sdk.Printer.Impl;

namespace UseAAR
{
    [Activity(Label = "@string/app_name", Theme = "@style/AppTheme", MainLauncher = true)]
    public class MainActivity : AppCompatActivity
    {
        TextView tvLog;
        Button btnOpen,btnPrint,btnClose;
        PrinterDeviceImpl printerDevice;

        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);
            Xamarin.Essentials.Platform.Init(this, savedInstanceState);
            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.activity_main);
            btnOpen = (Button)FindViewById(Resource.Id.btnOpen);
            btnPrint = (Button)FindViewById(Resource.Id.btnPrint);
            btnClose = (Button)FindViewById(Resource.Id.btnClose);
            tvLog = (TextView)FindViewById(Resource.Id.tv_log);
            btnOpen.Click += BtnOpen_Click;
            btnPrint.Click += BtnPrint_Click;
            btnClose.Click += BtnClose_Click;

            Thread thread1 = new Thread(delegate ()
            {
                printerDevice = (PrinterDeviceImpl)POSTerminal.GetInstance(this).GetDevice(POSTerminal.DeviceNamePrinter);
                Log.Debug("UseAAR", "printerDevice = " + printerDevice);
            });
            thread1.Start();
        }

        private void BtnOpen_Click(object sender, System.EventArgs e)
        {
            try
            {
                printerDevice.Open();
                tvLog.SetText(Resource.String.btn_open);
            }
            catch (Exception ex) 
            {
                tvLog.SetText(Resource.String.btn_already_open);
                ex.PrintStackTrace();
            }
        }

        private void BtnPrint_Click(object sender, System.EventArgs e)
        {
            tvLog.SetText(Resource.String.btn_print);

            printerDevice.PrintText("Demo receipts\n" +
                            "MERCHANT COPY\n" +
                            "\n" +
                            "MERCHANT NAME\n" +
                            "SHXXXXXXCo.,LTD.\n" +
                            "530310041315039\n" +
                            "TERMINAL NO\n" +
                            "50000045\n" +
                            "OPERATOR\n" +
                            "50000045\n" +
                            "\n" +
                            "CARD NO\n" +
                            "623020xxxxxx3994 I\n" +
                            "ISSUER ACQUIRER\n" +
                            "\n" +
                            "TRANS TYPE\n" +
                            "PAY SALE\n" +
                            "PAY SALE\n" +
                            "\n" +
                            "DATE/TIME EXP DATE\n" +
                            "2005/01/21 16:52:32 2099/12\n" +
                            "REF NO BATCH NO\n" +
                            "165232857468 000001\n" +
                            "VOUCHER AUTH NO\n" +
                            "000042\n" +
                            "AMOUT:\n" +
                            "RMB:0.01\n" +
                            "\n" +
                            "BEIZHU\n" +
                            "SCN:01\n" +
                            "UMPR NUM:4F682D56\n" +
                            "TC:EF789E918A548668\n" +
                            "TUR:008004E000\n" +
                            "AID:A000000333010101\n" +
                            "TSI:F800\n" +
                            "ATC:0440\n" +
                            "APPLAB:PBOC DEBIT\n" +
                            "APPNAME:PBOC DEBIT\n" +
                            "AIP:7C00\n" +
                            "CUMR:020300\n" +
                            "IAD:07010103602002010A01000000000005DD79CB\n" +
                            "TermCap:EOE1C8\n" +
                            "CARD HOLDER SIGNATURE\n" +
                            "I ACKNOWLEDGE SATISFACTORY RECEIPT OF RELATIVE GOODS/SERVICE\n" +
                            "I ACKNOWLEDGE SATISFACTORY RECEIPT OF RELATIVE GOODS/SERVICE\n" +
                            "I ACKNOWLEDGE SATISFACTORY RECEIPT OF RELATIVE GOODS/SERVICE\n\n\n"
);
        }

        private void BtnClose_Click(object sender, System.EventArgs e)
        {
            try
            {
                printerDevice.Close();
                tvLog.SetText(Resource.String.btn_close);

            }
            catch (Exception ex)
            {
                tvLog.SetText(Resource.String.btn_already_close);
                ex.PrintStackTrace();
            }
        }



        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            Xamarin.Essentials.Platform.OnRequestPermissionsResult(requestCode, permissions, grantResults);

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }
    }
}